<template>
  <div class="col-12 d-flex justify-content-center mt-5">
    <b-card no-body class="shadow mb-4 col-8">
        <h3 class="text-primary text-center mt-5 font-weight-bold">CRUD basico en laravel y vue js</h3>
      <!-- DATATABLE -->
      <vue-good-table
      class="p-5"
        :columns="columns"
        :rows="rows"
        :search-options="{ enabled: true }"
        :pagination-options="{ enabled: true }"
        :line-numbers="true"
      >
        <div slot="table-actions">
          <button v-on:click="addData()" class="btn btn-primary">
            A&ntilde;adir
          </button>
        </div>
        <template slot="table-row" slot-scope="props">
          <span v-if="props.column.field === 'name'">
            {{ props.row.name }}
          </span>
          <span v-else-if="props.column.field === 'active'">
            <div v-if="props.row.active === 1">Activo</div>
            <div v-else>Inactivo</div>
          </span>
          <span v-else-if="props.column.field === 'delete'">
            <button v-on:click="editData(props.row.id)" class="btn btn-warning">
              Editar
            </button>
            <button
              v-on:click="deleteData(props.row.id)"
              class="btn btn-danger"
            >
              Eliminar
            </button>
          </span>
          <span v-else>
            {{ props.formattedRow[props.column.field] }}
          </span>
        </template>
      </vue-good-table>
      <!-- MODAL -->
      <b-modal
        ok-title="Guardar"
        cancel-title="Cancelar"
        id="modal-movie"
        ref="modal"
        title="Tipo de Cicloparqueadero"
        @show="resetModal"
        @hidden="resetModal"
        @ok="handleOk"
      >
        <form ref="form" @submit.stop.prevent="dataSubmit">
          <b-form-input
            ref="idInput"
            class="d-none"
            v-model="id"
          ></b-form-input>
          <b-form-group label="Nombre" label-for="name-input">
            <b-form-input
              ref="nameInput"
              id="name-input"
              v-model="name"
              required
            ></b-form-input>
          </b-form-group>
          <b-form-group label="Estado" label-for="active-input">
            <b-form-select
              ref="activeInput"
              id="active-input"
              required
              v-model="active"
            >
              <b-form-select-option :value="null"
                >Selecciona una opci&oacute;n</b-form-select-option
              >
              <b-form-select-option value="1">Si</b-form-select-option>
              <b-form-select-option value="2"
                >No</b-form-select-option
              ></b-form-select
            >
          </b-form-group>
        </form>
      </b-modal>
    </b-card>
  </div>
</template>

<script>
import toastr from "toastr";
import Swal from "sweetalert2";
export default {
  data() {
    return {
      id: null,
      name: null,
      active: null,
      columns: [
        {
          label: "Nombre",
          field: "name",
        },
        {
          label: "Estado",
          field: "active",
        },
        {
          label: "Acciones",
          field: "delete",
        },
      ],
      rows: [],
    };
  },
  methods: {
    addData() {
      this.$bvModal.show("modal-movie");
    },
    handleOk(bvModalEvt) {
      // Prevent modal from closing
      bvModalEvt.preventDefault();
      // Trigger submit handler
      this.dataSubmit();
    },
    dataSubmit() {
      if (this.$refs.idInput.value) {
        axios
          .put("/api/movie/update", {
            id: this.$refs.idInput.value,
            name: this.$refs.nameInput.value,
            active: this.$refs.activeInput.value,
          })
          .then((res) => {
            if (res.data.status == 1) {
              this.getData();
              toastr.success(res.data.response);
              this.$bvModal.hide("modal-movie");
            } else {
              this.getData();
              toastr.error(res.data.response);
            }
          })
          .catch((e) => {
            toastr.error("Error al guardar, comunicate con soporte tecnico");
            console.error(e);
          });
      } else {
        axios
          .post("/api/movie", {
            name: this.$refs.nameInput.value,
            active: this.$refs.activeInput.value,
          })
          .then((res) => {
            if (res.data.status == 1) {
              this.getData();
              toastr.success(res.data.response);
              this.$bvModal.hide("modal-movie");
            } else {
              this.getData();
              toastr.error(res.data.response);
            }
          })
          .catch((e) => {
            toastr.error("Error al guardar, comunicate con soporte tecnico");
            console.error(e);
          });
      }
    },
    resetModal() {
      this.name = "";
      this.active = null;
      this.id = "";
    },
    deleteData(data) {
      const swalWithBootstrapButtons = Swal.mixin({
        customClass: {
          confirmButton: "btn btn-success",
          cancelButton: "btn btn-danger",
        },
        buttonsStyling: false,
      });

      swalWithBootstrapButtons
        .fire({
          title: "Estas Seguro De Eliminar Este Dato?",
          text: "Esta opcion no se puede reversar",
          icon: "warning",
          showCancelButton: false,
          confirmButtonText: "Eliminar",
          timer: 5000,
          timerProgressBar: true,
        })
        .then((result) => {
          if (result.isConfirmed) {
            axios
              .delete("/api/movie/" + data)
              .then((res) => {
                if (res.data.status == 1) {
                  toastr.success(res.data.response);
                  this.getData();
                } else {
                  this.getData();
                  toastr.error(res.data.response);
                }
              })
              .catch((e) => {
                toastr.error(
                  "error al guardar, comunicate con soporte tecnico"
                );
                console.error(e);
              });
          }
        });
    },
    editData(data) {
      axios
        .get("/api/movie/" + data + "/edit")
        .then((res) => {
          this.id = res.data.id;
          this.name = res.data.name;
          this.active = res.data.active;
        })
        .catch((err) => {
          console.log(err);
        });
      this.$bvModal.show("modal-movie");
    },
    getData() {
      axios
        .get("/api/movie")
        .then((res) => {
          this.rows = res.data;
        })
        .catch((err) => {
          console.log(err);
        });
    },
  },
  mounted: function () {
    this.getData();
  },
};
</script>
